const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const teachers = sequelize.define(
    'teachers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      full_name: {
        type: DataTypes.TEXT,
      },

      subject_specialization: {
        type: DataTypes.TEXT,
      },

      phone_number: {
        type: DataTypes.TEXT,
      },

      joining_date: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  teachers.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.teachers.hasMany(db.assignments, {
      as: 'assignments_teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.class_subjects, {
      as: 'class_subjects_teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.classes, {
      as: 'classes_class_teacher',
      foreignKey: {
        name: 'class_teacherId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.lesson_plans, {
      as: 'lesson_plans_teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.student_attendance, {
      as: 'student_attendance_marked_by',
      foreignKey: {
        name: 'marked_byId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.teacher_attendance, {
      as: 'teacher_attendance_teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    db.teachers.hasMany(db.timetables, {
      as: 'timetables_teacher',
      foreignKey: {
        name: 'teacherId',
      },
      constraints: false,
    });

    //end loop

    db.teachers.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.teachers.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });

    db.teachers.belongsTo(db.schools, {
      as: 'schools',
      foreignKey: {
        name: 'schoolsId',
      },
      constraints: false,
    });

    db.teachers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.teachers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return teachers;
};
